// Polyfill for Date.now
Date.now = (Date.now || function () {  // thanks IE8
	return new Date().getTime();
});

var FUNCTION_END_TYPE = 'OperationExecutionRecord';

var currentTime = function () {
	return Date.now().toString();
};

module.exports = function (kieker) {
	var handle = {
		apply: function (target, thisArg, argumentsList) {
			var methodName = target.name || 'anonymous';
			var args = Array.prototype.slice.call(arguments);

			var tin = currentTime();
			var result = target.apply(thisArg, argumentsList);

			kieker.sendProbe({
				args: args.map(function (item) {
					try {
						return item && String(item);
					} catch (e) {
						return 'unknown';
					}
				}),
				operationSignature: methodName,
				result,
				tin,
				tout: currentTime(),
				timestamp: currentTime(),
				type: FUNCTION_END_TYPE
			});

			return result;
		}
	};

	kieker.instrumentFunction = function (target) {
		if (!target) {
			return;
		}

		return new Proxy(target, handle);
	};

	return kieker;
};
